(function ($) {
  Drupal.behaviors.cookieConsentNotice = {
    attach: function (context) {
      let newDiv = document.createElement('div');

      let parentElement = '';
      let cookiesListItems = '';
      let cookiesClassItems = '';
      let cookieClass = '';

      if ($('.cookieconsent-optin-preferences', context).length) {
        let translatablePreferences = Drupal.t('Preferences');
        cookiesListItems += '<li style="display: list-item;" class="cookieconsent-optout-preferences">' + translatablePreferences + '</li>';
        if (jQuery('.cookieconsent-optin-preferences').css('display') !== 'none') {
          cookiesClassItems = 'cookieconsent-optout-preferences';
        }
        parentElement = $('.cookieconsent-optin-preferences').parent();
        cookieClass = '.cookieconsent-optin-preferences';
      }
      if ($('.cookieconsent-optin-statistics', context).length) {
        let translatableStatistics = Drupal.t('Statistics');
        cookiesListItems += '<li style="display: list-item;" class="cookieconsent-optout-statistics">' + translatableStatistics + '</li>';
        if (jQuery('.cookieconsent-optin-statistics').css('display') !== 'none') {
          cookiesClassItems = 'cookieconsent-optout-statistics';
        }
        parentElement = $('.cookieconsent-optin-statistics').parent();
        cookieClass = '.cookieconsent-optin-preferences';
      }
      if ($('.cookieconsent-optin-marketing', context).length) {
        let translatableMarketing = Drupal.t('Marketing');
        cookiesListItems += '<li style="display: list-item;" class="cookieconsent-optout-marketing">' + translatableMarketing + '</li>';
        if (jQuery('.cookieconsent-optin-marketing').css('display') !== 'none') {
          cookiesClassItems = 'cookieconsent-optout-marketing';
        }
        parentElement = $('.cookieconsent-optin-marketing').parent();
        cookieClass = '.cookieconsent-optin-marketing';
      }

      newDiv.innerHTML = Drupal.t('To view this content, you need to <a href="@renewLink">accept the following cookies:</a>', {'@renewLink': 'javascript:CookieConsent.renew()'}) +
          '<ul>' + cookiesListItems + '</ul>';

      newDiv.className = 'cookie-consent-div ' + cookiesClassItems;

      // only append the new div if the parent element exists
      if (parentElement !== '') {
        parentElement.append(newDiv);
      }

      // repeatedly check if the iframe is being displayed, if it is then remove
      // the cookies message div before the user has set any cookies the display
      // sometimes needs a bit of help...
      let displayCheckInterval = setInterval(function() {
        if (jQuery(cookieClass)) {
          let iframeDisplayStyle = jQuery(cookieClass).css('display');

          if (iframeDisplayStyle !== 'none') {
            $('.cookie-consent-div').css('display', 'none');

            // kill the interval to prevent unnecessary processing overhead
            clearInterval(displayCheckInterval);
          }
        }
      }, 500);
    }
  };
})(jQuery);
